!------------------------------------------!
!  Program Shift                           !
!  Circular Shift                          !
!------------------------------------------!

program main

      use mpi
      implicit none

      integer i, j
      integer ierr, rank, size
      integer rank_cart
      integer tag, tag1, dest, source
      integer value, north, south, east, west
      real*8 average, toBePrinted

      integer status(MPI_STATUS_SIZE)

!      cartesian topology 
       integer comm_cart
       integer dims(2)/0,0/, coords(2)
       logical periods(2)/.TRUE.,.TRUE./


!--- Start up MPI  ----------------------------------------------------------
      call MPI_INIT(ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)

      value = rank

      call MPI_Dims_create(size, 2, dims, ierr)
      call MPI_Cart_create(MPI_COMM_WORLD, 2, dims, periods, .FALSE., &
           comm_cart, ierr)

      tag =200
      tag1=201

! to north/from south
      call MPI_Cart_shift(comm_cart, 0, 1, source, dest, ierr)
      call MPI_Sendrecv(value, 1, MPI_INTEGER, dest, tag, south, 1, &
           MPI_INTEGER, source, tag, MPI_COMM_WORLD, status, ierr)
! to south/from north
      call MPI_Cart_shift(comm_cart, 0, -1, source, dest, ierr)
      call MPI_Sendrecv(value, 1, MPI_INTEGER, dest, tag1, north, 1, &
           MPI_INTEGER, source, tag1, MPI_COMM_WORLD, status, ierr)
! to east/from west
      call MPI_Cart_shift(comm_cart, 1, 1, source, dest, ierr)
      call MPI_Sendrecv(value, 1, MPI_INTEGER, dest, tag, west, 1, &
           MPI_INTEGER, source, tag, MPI_COMM_WORLD, status, ierr)
! to west/from east
      call MPI_Cart_shift(comm_cart, 1, -1, source, dest, ierr)
      call MPI_Sendrecv(value, 1, MPI_INTEGER, dest, tag1, east, 1, &
           MPI_INTEGER, source, tag1, MPI_COMM_WORLD, status, ierr)

      average = 0.25d0 * (north + south + east + west)

! writing results
      if (rank .eq. 0) then
         call MPI_Comm_rank(comm_cart, rank_cart,ierr)
         do i = 1, dims(1)
            do j = 1, dims(2)
               coords(1) = i - 1  
               coords(2) = j - 1
               call  MPI_Cart_rank(comm_cart, coords, source, ierr)
               if ( .not.(source .eq. rank_cart)) then
                  call  MPI_Recv( toBePrinted, 1, MPI_DOUBLE_PRECISION, &
                            source, tag, comm_cart, status, ierr)
                   write(*,fmt="(i2,':(',i2,',',i2,')',f6.2,5x)",advance="no") &
                            source, i, j, toBePrinted
               else
                   write(*,fmt="(i2,':(',i2,',',i2,')',f6.2,5x)",advance="no") &
                            source, i, j, average
               endif
            end do
            write(*,*)
         end do
      else
         call MPI_SEND(average, 1, MPI_DOUBLE_PRECISION, 0, tag, &
             comm_cart, ierr)
      endif


      call MPI_FINALIZE(ierr)

end program main

