program laplace

    implicit none
    double precision, dimension(:), allocatable :: T, Tnew
    double precision :: tol, variation=1.0
    integer :: msize, maxIter, i, iter=0
    integer :: startTime(8), endTime(8)

    write(*,*) 'Enter mesh size, max iterations and tollerance:'
    read(*,*)  msize, maxIter, tol

    call date_and_time(values=startTime)

    allocate (T(0:msize+1), Tnew(msize))

    T(0:msize) = 0.0
    T(msize+1) = 100.0

    do while (variation > tol .and. iter <= maxIter)
        iter = iter + 1
        Tnew = 0.5 * ( T(0:msize-1) + T(2:msize+1) )
        variation = maxval(dabs( Tnew - T(1:msize) ))
        if( mod(iter,100) == 0 ) write(*,"(a,i8,e12.4)") &
            ' iter, variation:', iter, variation
        T(1:msize) = Tnew
    enddo

    call date_and_time(values=endTime)

    write(*,'(A,F10.4)') ' Elapsed time (s)     =', &
            (endTime(5) - startTime(5))*3600.d0 +   &
            (endTime(6) - startTime(6))*60.d0 +     &
            (endTime(7) - startTime(7)) +           &
            (endTime(8) - startTime(8))/1000.d0

    write(*,*) 'Mesh size            =', msize
    write(*,*) 'Stopped at iteration =', iter
    write(*,*) 'The maximum error    =', variation
    
    open(10, file="results")
    do i = 1, msize
        write(10, "(i8, e18.9)") i, T(i)
    end do
    close(10)
    
    deallocate (T, Tnew)

end program laplace
